#include <gtk/gtk.h>
#define NO_PADDING 0
#define NO_SPACING 0

/* Callbacks */
void quit( GtkButton *was_clicked, gpointer user_data )
{
   gtk_main_quit();
}
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data )
{
    g_print("Received closure from the window manager\n");
    return( FALSE );  /* FALSE - do not prevent closure */
}
   

int main( gint argc, gchar *argv[] )
{
  GtkWidget *top_widget;
  GtkWidget *vbox, *menu_bar, *file_item, *file_menu, *exit_item;
  GtkWidget *drawing_area;
  GtkWidget *help_item;

   /* 1. Initialize the environment */
    gtk_init( &argc, &argv );

  /* 2a. Create widgets */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    gtk_widget_set_name( top_widget, "gtk_simple" );
    vbox = gtk_vbox_new( FALSE, NO_SPACING );
    gtk_widget_set_name( vbox, "vbox" );
    menu_bar = gtk_menu_bar_new( );
    gtk_widget_set_name( menu_bar, "mbar" );

    /* Create the File item and its menu */
    file_item = gtk_menu_item_new_with_label( "File" );
    gtk_widget_set_name( file_item, "file" );
    file_menu = gtk_menu_new();
    gtk_widget_set_name( file_menu, "fmenu" );
    exit_item = gtk_menu_item_new_with_label( "Exit" );
    gtk_widget_set_name( exit_item, "exit" );
 
   /* Create the Help item */
    help_item = gtk_menu_item_new_with_label( "Help" );
    gtk_widget_set_name( help_item, "help" );

   /* Create the Work Area */
    drawing_area = gtk_drawing_area_new();
    gtk_widget_set_name( help_item, "drawing" );

  /* 2b. Set Attributes */
    gtk_window_set_title( GTK_WINDOW( top_widget ), "User interface" );
    gtk_drawing_area_size( GTK_DRAWING_AREA(drawing_area), 200, 200 );

  /* 3. Registering Callback routines */
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete_event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(quit), NULL );
    gtk_signal_connect( GTK_OBJECT( exit_item ), "activate", quit, NULL );

  /* 4. Defining the Instance Hierarchy */
    gtk_container_add( GTK_CONTAINER( top_widget ), vbox );
    gtk_box_pack_start( GTK_BOX(vbox), menu_bar, FALSE, FALSE, NO_PADDING);
    gtk_box_pack_start( GTK_BOX(vbox), drawing_area, FALSE, FALSE, NO_PADDING );

    /* Pack the Menu Bar and move Help to Far Right */
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), file_item );
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), help_item );
    gtk_menu_item_right_justify( GTK_MENU_ITEM(help_item) );

    /* Attach and pack the menus */
    gtk_menu_item_set_submenu( GTK_MENU_ITEM( file_item ), file_menu );
    gtk_menu_append( GTK_MENU(file_menu), exit_item );

  /* 5. Showing the Widgets */
    gtk_widget_show_all( top_widget );

  /* 6. Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
