#include <gtk/gtk.h>
#define HOMOGENEOUS_FALSE FALSE
#define PADDING 0

GtkWidget *append_menu_item( GtkMenu *menu, const gchar *text, 
                   GtkSignalFunc callback, gpointer user_data);
gboolean dialog_delete_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
void print_and_quit( GtkButton *was_clicked, gpointer user_data );
void plot_values( GtkButton *was_clicked, gpointer user_data );
GtkWidget *create_file_and_menu( GtkMenuBar *menu_bar );
GtkWidget *create_top_window( const gchar*title );
void ok_callback( GtkWidget *was_clicked, GtkWidget *fontsel );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *pie_area;
  GtkWidget *menu_bar, *pie_item, *pie_menu ;
  GtkWidget *font_item, *fontsel_dlg;

   /*  Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create toplevel widget */
    top_widget = create_top_window( "Pie Chart");

  /* Create managing vertical box widget */
    box = gtk_vbox_new( HOMOGENEOUS_FALSE, PADDING );
    gtk_container_add( GTK_CONTAINER( top_widget ), box );

  /* Create the menu bar widget */
    menu_bar = gtk_menu_bar_new( );
    gtk_box_pack_start_defaults( GTK_BOX( box ), menu_bar );

   /* Create the drawing area widget */
    pie_area = gtk_drawing_area_new( );
    gtk_drawing_area_size(GTK_DRAWING_AREA(pie_area), 200, 250 );
    gtk_box_pack_start_defaults( GTK_BOX( box ), pie_area);

    /* Create the File item and its menu widget */
    create_file_and_menu( GTK_MENU_BAR(menu_bar) );

    /* Create the Pie item and its menu widget */
     pie_item = gtk_menu_item_new_with_label( "Pie" );
     gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), pie_item );
      pie_menu = gtk_menu_new();
      gtk_menu_item_set_submenu( GTK_MENU_ITEM( pie_item ), pie_menu );
    
     /* Create Pie menu items */
     font_item = append_menu_item( GTK_MENU(pie_menu),  "Change Font", 
                                   NULL, NULL );
     append_menu_item( GTK_MENU(pie_menu),  NULL, NULL, NULL );
     append_menu_item( GTK_MENU(pie_menu),  "Draw pie chart", plot_values, 
                       pie_area );

    /* Create the Font Selection Dialog, and attach the signal handler 
       to bring it up */
    fontsel_dlg = gtk_font_selection_dialog_new( "Select Pie label's new font");
    gtk_signal_connect_object( GTK_OBJECT( font_item ), "activate",
                        GTK_SIGNAL_FUNC(gtk_widget_show), GTK_OBJECT(fontsel_dlg) );
    gtk_signal_connect( GTK_OBJECT( fontsel_dlg ), "delete_event",
                        GTK_SIGNAL_FUNC(dialog_delete_handler), NULL );

    gtk_signal_connect( GTK_OBJECT( 
                        GTK_FONT_SELECTION_DIALOG(fontsel_dlg)->ok_button ),
                        "clicked", ok_callback, fontsel_dlg );
    gtk_signal_connect_object( GTK_OBJECT(
                     GTK_FONT_SELECTION_DIALOG(fontsel_dlg)->cancel_button ),
                     "clicked",
                     GTK_SIGNAL_FUNC(gtk_widget_hide), GTK_OBJECT(fontsel_dlg) );

  /* Show the widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
