#include <gtk/gtk.h>
#define NUM_REGIONS 4

typedef struct {
   GtkWidget *drawing_area;
   gint n;
   gint percents[NUM_REGIONS];
} Pie_chart_data; 

GdkFont *label_font=NULL;

void ok_callback( GtkWidget *was_clicked, GtkWidget *font_dlg )
{
   label_font = gtk_font_selection_dialog_get_font(
                           GTK_FONT_SELECTION_DIALOG( font_dlg ) );
   gtk_widget_hide( font_dlg );
} 

void draw_pie_slice( GtkWidget *where, GdkGC *gc, guint start, guint percent, gchar *label, guint pie_x, guint pie_y )
{
   static gint label_number=0;
   gint string_width, string_height;
   gint change_in_y;

   if (start == 0)
       label_number = 0;
   gdk_draw_arc( where->window, gc, TRUE, 0, 0, pie_x, pie_y, 
                 start*360*64/100, percent*360*64/100 );
   string_width = gdk_string_width( where->style->font, label );
   string_height = gdk_string_height( where->style->font, label );

   change_in_y = 1.3*label_number*string_height;
   gdk_draw_rectangle( where->window, gc, TRUE, 20, 40+pie_y+change_in_y, 
                       10, string_height );
   gdk_draw_string( where->window, where->style->font, gc,
                    35,40+pie_y+string_height+change_in_y, label );
   label_number++;
}

void plot_values( GtkMenuItem *was_clicked, GtkWidget *plot_area )
{
   Pie_chart_data pie_data;
   GdkColor color[4];
   gchar *pie_label[4] = { "Northern", "Southern", "Western", "Eastern" };
   gint x_size=150, y_size=150;
   gint i, start=0;
   static GdkGC *pie_gc[4]={ NULL, NULL, NULL, NULL };
   gint string_width, string_height;
   gchar *string = "Sales by Region";

   pie_data.percents[0] = 25;
   pie_data.percents[1] = 10;
   pie_data.percents[2] = 50;
   pie_data.percents[3] = 15;

 /* Get yellow */
     color[0].red = 0xffff; color[0].green = 0xffff; color[0].blue = 0;
     if (!gdk_color_alloc(gdk_colormap_get_system(), &color[0])) {
       g_error("couldn't allocate yellow");
     }
 /* Get blue */
     color[1].red = 0; color[1].green = 0; color[1].blue = 0xffff;
     if (!gdk_color_alloc(gdk_colormap_get_system(), &color[1])) {
       g_error("couldn't allocate blue");
     }
 /* Get red */
     color[2].red = 0xffff; color[2].green = 0; color[2].blue = 0;
     if (!gdk_color_alloc(gdk_colormap_get_system(), &color[2])) {
       g_error("couldn't allocate red");
     }
 /* Get green */
     color[3].red = 0; color[3].green = 0xffff; color[3].blue = 0;
     if (!gdk_color_alloc(gdk_colormap_get_system(), &color[3])) {
       g_error("couldn't allocate green");
     }


    /* Drawing the label (Listing 10.7) */
    gdk_window_clear( plot_area->window);
    if( label_font == NULL)
      label_font = gdk_font_load("-*-helvetica-bold-r-normal-*-14-*-*-*-*-*-*-*");
    string_width = gdk_string_width( label_font, string);
    string_height = gdk_string_height( label_font, string);
    gdk_draw_string( plot_area->window, label_font, plot_area->style->black_gc,
                     (x_size-string_width)/2, y_size+string_height, string );
       
     /* Draw the pie chart */
     for( i=0; i<4; i++)
     {
        pie_gc[i]=gdk_gc_new( plot_area->window ); 
        gdk_gc_set_foreground( pie_gc[i], &color[i] );
      }

    for (i=0; i<4; i++)
    {
         draw_pie_slice( plot_area, pie_gc[i], start, pie_data.percents[i], 
                         pie_label[i], 150,  150 );
        start += pie_data.percents[i];
    }
}
