#include <gtk/gtk.h>

/* Callbacks */
GtkWidget *append_menu_item( GtkMenu *menu, const gchar *text, 
                   GtkSignalFunc callback, gpointer user_data);
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
void print_and_quit( GtkButton *was_clicked, gpointer user_data );

void animate_smiley( GtkWidget *widget,  GtkWidget *area );
void stop_smiley( GtkWidget *widget,  GtkWidget *area );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *label, *drawing;
  GtkWidget *menu_bar, *file_item, *file_menu ;
  GtkWidget *smile_item, *smiley_hbox, *smiley_icon, *smiley_label;
  GdkPixmap *small_smiley;
  GdkBitmap *transparent;

   /*  Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create toplevel widget */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    gtk_window_set_title( GTK_WINDOW( top_widget ), "Smile" );
    gtk_widget_set_name( top_widget, "smile");
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete-event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );

  /* Create managing vertical box widget */
    box = gtk_vbox_new( FALSE, 0 );
    gtk_container_add( GTK_CONTAINER( top_widget ), box );

  /* Create the menu bar widget */
    menu_bar = gtk_menu_bar_new( );
    gtk_box_pack_start_defaults( GTK_BOX( box ), menu_bar );

    /* Create the File item and its menu widget */
     file_item = gtk_menu_item_new_with_label( "File" );
     gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), file_item );
      file_menu = gtk_menu_new();
      gtk_menu_item_set_submenu( GTK_MENU_ITEM( file_item ), file_menu );
    
    /* Create the entries in the File menu */
      /* Create Smile Entry */
      smile_item = gtk_menu_item_new();
      gtk_menu_append( GTK_MENU( file_menu ), smile_item );

      smiley_hbox = gtk_hbox_new( FALSE, 0 );
      gtk_container_add( GTK_CONTAINER( smile_item ), smiley_hbox );

      /* Create Smile icon */
      small_smiley = gdk_pixmap_colormap_create_from_xpm( NULL,
                     gdk_colormap_get_system() , &transparent, NULL, 
                     "small-smiley.xpm");
      smiley_icon = gtk_pixmap_new( small_smiley, transparent );
      gdk_pixmap_unref( small_smiley );
      gtk_box_pack_start_defaults( GTK_BOX( smiley_hbox ), smiley_icon);

      /* Create Smile Label */
      smiley_label = gtk_label_new( "Smile" );
      gtk_box_pack_start_defaults( GTK_BOX( smiley_hbox ), smiley_label );


     /* Create other File menu items */
     append_menu_item( GTK_MENU(file_menu), "Stop Smile" , stop_smiley, NULL );
     append_menu_item( GTK_MENU(file_menu),  NULL, NULL, NULL );
     append_menu_item( GTK_MENU(file_menu),  "Exit", print_and_quit, NULL );

  /* Create the FUN label widget */
    label = gtk_label_new( "GTK+ is fun!");
    gtk_box_pack_start_defaults( GTK_BOX( box ), label );

  /* Create the drawing area widget */
    drawing = gtk_drawing_area_new( );
    gtk_drawing_area_size(GTK_DRAWING_AREA(drawing), 200, 200 );
    gtk_box_pack_start_defaults( GTK_BOX( box ), drawing );

   /* Attach animate_smiley */
      gtk_signal_connect( GTK_OBJECT( smile_item ), "activate",
                          GTK_SIGNAL_FUNC(animate_smiley), drawing );
  /* Show the widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
