#include <gtk/gtk.h>

#define NUM_SMILES 4
static GdkGC *smiley_gc;
static GdkPixmap *smiley[NUM_SMILES]= {NULL, NULL, NULL, NULL};
static guint smile_tag = 0;
void create_smileys(GtkWidget *area);
gint switch_smiley(  gpointer data );

void animate_smiley( GtkWidget *widget,  GtkWidget *area  )
{
  /* Set up the pixmaps */
  if (smiley[0] == NULL)
     create_smileys(area);

  smile_tag = gtk_timeout_add( 500, switch_smiley, area);
}

void stop_smiley( GtkWidget *widget,  gpointer data  )
{
  /* Check smile_tag to be sure aren't trying to stop when haven't started */
  if ( smile_tag != 0 )
     gtk_timeout_remove(smile_tag);
}

gint switch_smiley( gpointer data )
{
 GtkWidget *area = GTK_WIDGET(data);
 static int count = 0, up=TRUE;
 gdk_draw_pixmap( area->window, smiley_gc, smiley[count], 
                  0, 0, 10, 10, 160, 160 );
  if( up )
  {
     count++;
     if(count == 3)
        up = FALSE;
  }else{
    count--;
    if (count == 0)
       up = TRUE;
  }
  return 1;
}
void create_smileys(GtkWidget *area)
{
   int i;
   GdkColor color, black;

     gdk_color_black( gdk_colormap_get_system(), &black );
     smiley_gc = gdk_gc_new(area->window);
     gdk_gc_set_foreground( smiley_gc, &black );
     for( i=0; i<NUM_SMILES; i++)
     {
       smiley[i] = gdk_pixmap_new( area->window, 160, 160, -1 );
       gdk_draw_rectangle( smiley[i], smiley_gc, TRUE, 0, 0, 160, 160 );
     }
     color.red = 0xffff;   color.green = 0xffff;   color.blue = 0;
     if (!gdk_color_alloc(gdk_colormap_get_system(), &color)) {
       g_error("couldn't allocate yellow");
     }
     gdk_gc_set_foreground( smiley_gc, &color );
     /* Draw yellow face */
     for( i=0; i<NUM_SMILES; i++)
       gdk_draw_arc( smiley[i], smiley_gc, TRUE, 0,0,160,160,0,360*64);

     /* Draw blue eyes */
     color.red = 0;   color.green = 0;   color.blue = 0xffff;
     if (!gdk_color_alloc(gdk_colormap_get_system(), &color)) {
       g_error("couldn't allocate blue");
     }
     gdk_gc_set_foreground( smiley_gc, &color );
     gdk_draw_arc( smiley[0], smiley_gc, TRUE, 40,30, 20, 40, 0, 360*64);
     gdk_draw_arc( smiley[0], smiley_gc, TRUE, 100,30, 20, 40, 0, 360*64);
     for (i=1; i<NUM_SMILES; i++)
     {
        /* Same eyes on rest of smilers */
        gdk_draw_arc( smiley[i], smiley_gc, TRUE, 40,40, 20, 20, 0, 360*64);
        gdk_draw_arc( smiley[i], smiley_gc, TRUE, 100,40, 20, 20, 0, 360*64);
     }

     /* Draw smile */
     color.red = 0xffff;   color.green = 0;   color.blue = 0;
     if (!gdk_color_alloc(gdk_colormap_get_system(), &color)) {
       g_error("couldn't allocate red");
     }
     gdk_gc_set_foreground( smiley_gc, &color );
     gdk_draw_arc( smiley[0], smiley_gc, FALSE, 30,60, 100, 80, 180*64, 180*64);
     gdk_draw_arc( smiley[1], smiley_gc, FALSE, 30,90, 100, 40, 200*64, 140*64);
     gdk_draw_line( smiley[2], smiley_gc, 40, 110, 120, 110);
     gdk_draw_arc( smiley[3], smiley_gc, FALSE, 30,110, 100, 40, 20*64, 140*64);

}
