#include <gtk/gtk.h>
#define X_AXIS 180
#define Y_AXIS 175
#define X_PAD 20
#define Y_PAD 10
#define NUM_PTS 10
#define X 0
#define Y 1

gboolean  show_coord( GtkWidget *darea, GdkEventButton *event, GtkWidget *label)
{
   GtkWidget *popup = gtk_widget_get_ancestor( label, gtk_window_get_type() );
   gint x=event->x-X_PAD;
   gint y= Y_AXIS+Y_PAD-event->y;
   gchar *coords = g_strdup_printf("%d, %d\n",x, y);

   gtk_label_set_text( GTK_LABEL(label), coords );
   gtk_widget_popup( popup, event->x_root, event->y_root );
   return TRUE;
}

void line_plot( GtkMenuItem *was_clicked, GtkWidget *where_to_draw )
{
   static gint to_plot[NUM_PTS][2] = { {0, 0}, {15, 20}, {30, 80}, 
                              {45, 30}, {60, 25}, {75, 90}, {90, 120}, 
                              {105, 170}, {120, 100}, {135, 0} };
   GdkGC *plot_gc;
   int pts;

   /* Retrieve "black" GC */
    plot_gc = GTK_WIDGET(where_to_draw)->style->black_gc ;

  /* Draw Axis */
   gdk_draw_line( GTK_WIDGET(where_to_draw)->window, plot_gc, 
                  X_PAD, Y_AXIS + Y_PAD, X_PAD, Y_PAD );
   gdk_draw_line( GTK_WIDGET(where_to_draw)->window, plot_gc,
                  X_PAD, Y_AXIS + Y_PAD, X_PAD + X_AXIS, Y_AXIS + Y_PAD );
   
  /* Plot */
   for( pts = 1; pts < NUM_PTS; pts++)
        gdk_draw_line( GTK_WIDGET(where_to_draw)->window, plot_gc,
               to_plot[pts-1][X] + X_PAD, Y_AXIS + Y_PAD - to_plot[pts-1][Y],
               to_plot[pts][X] + X_PAD, Y_AXIS + Y_PAD - to_plot[pts][Y] );

}

