#include <gtk/gtk.h>

#define HOMOGENEOUS_FALSE FALSE
#define PADDING 0

GtkWidget *create_file_and_menu( GtkMenuBar *menu_bar );
GtkWidget *create_top_window( const gchar*title );
gboolean show_coord( GtkWidget *widget, GdkEventButton *event,
                               gpointer user_data );
void line_plot( GtkWidget *was_clicked, GtkWidget *plot_area );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *menu_bar, *plot_area; 
  GtkWidget *file_item, *plot_item;
  GtkWidget *coord_popup, *coord_label;

   /*  Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create a pop-up label */
    coord_popup = gtk_window_new( GTK_WINDOW_POPUP );
    coord_label = gtk_label_new( "Coordinates" );
    gtk_widget_show( coord_label );
    gtk_container_add( GTK_CONTAINER( coord_popup ), coord_label );
    

  /* Create toplevel widget */
    top_widget = create_top_window( "Line Plot");

  /* Create managing vertical box widget */
    box = gtk_vbox_new( HOMOGENEOUS_FALSE, PADDING );
    gtk_container_add( GTK_CONTAINER( top_widget ), box );

  /* Create the menu bar widget */
    menu_bar = gtk_menu_bar_new( );
    gtk_box_pack_start_defaults( GTK_BOX( box ), menu_bar );

   /* Create the drawing area widget */
    plot_area = gtk_drawing_area_new( );
    gtk_drawing_area_size(GTK_DRAWING_AREA(plot_area), 200, 250 );
    gtk_box_pack_start_defaults( GTK_BOX( box ), plot_area);
    gtk_signal_connect( GTK_OBJECT(plot_area), "button-press-event", 
                        GTK_SIGNAL_FUNC(show_coord), coord_label );
    gtk_signal_connect_object( GTK_OBJECT(plot_area), "button-release-event", 
                     GTK_SIGNAL_FUNC(gtk_widget_hide),GTK_OBJECT(coord_popup) );
    gtk_widget_set_events( plot_area, 
                           GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK );

   /* Create the File item and its menu widget */
    file_item = create_file_and_menu( GTK_MENU_BAR(menu_bar) );

   /* Create the Plot item */
    plot_item = gtk_menu_item_new_with_label( "Plot" );
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), plot_item );
    gtk_signal_connect( GTK_OBJECT( plot_item ), "activate",
                        GTK_SIGNAL_FUNC(line_plot), plot_area );

  /* Show the widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}

