#include <gtk/gtk.h>
#define NCOLORS 4

void collect_color( GtkWidget *ok_button, GtkWidget *plot_area )
{
   GdkColor *user_color=g_malloc( sizeof( GdkColor ));
   gdouble new_color[3];
   GtkWidget *color_dialog;

   color_dialog = gtk_widget_get_ancestor( ok_button, 
                                           gtk_color_selection_dialog_get_type() ); 
   gtk_color_selection_get_color( GTK_COLOR_SELECTION(
                           GTK_COLOR_SELECTION_DIALOG(color_dialog)->colorsel), 
                            new_color );
   user_color->red = (guint16)(new_color[0] * 65535.0 );
   user_color->green = (guint16)(new_color[1] * 65535.0 );
   user_color->blue = (guint16)(new_color[2] * 65535.0 );

   gtk_object_set_data( GTK_OBJECT(plot_area), "User color", user_color );
   gtk_widget_hide( color_dialog ); 
}
void draw_pie_chart( GtkMenuItem *was_clicked, GtkWidget *plot_area )
{
   GdkColor color[NCOLORS], *user_color;
   GdkColormap *colormap=gdk_colormap_get_system();
   gboolean success_codes[NCOLORS];
   gint percents[]={ 25, 10, 50, 15 }, i, start=0;
   gchar *pie_label[] =  { "Northern", "Southern", "Western", "Eastern" };
   GdkGC *pie_gc;
   GdkPixmap *pie;
   gint x_size, y_size, label_height, y;

   x_size = plot_area->allocation.width;
   y_size = plot_area->allocation.height;
   label_height = gdk_string_height( plot_area->style->font, pie_label[0] );


  /* Parse 4 colors */
   user_color =  gtk_object_get_data( GTK_OBJECT(plot_area), "User color" );
   if( user_color )
      color[3] = *user_color;
   else
     if (!gdk_color_parse("ForestGreen", &color[3])) 
          g_error("couldn't parse green");
  /* blue */
     if (!gdk_color_parse("RoyalBlue", &color[1])) 
          g_error("couldn't parse blue");
  /* red */
     if (!gdk_color_parse("Red", &color[2])) 
          g_error("couldn't parse red");
  /* yellow */
     if (!gdk_color_parse("Yellow", &color[0])) 
        g_error("couldn't parse yellow");

   /* Create a new GC, and allocate colors */
      pie_gc=gdk_gc_new( plot_area->window ); 
      if (gdk_colormap_alloc_colors( colormap, color, NCOLORS,
                                      FALSE, TRUE, success_codes )) 
             g_error("couldn't allocate some of the colors");

  /* Create a pixmap, the size of the drawing area */
     pie = gdk_pixmap_new( plot_area->window, x_size, y_size, -1 );
     gdk_gc_set_foreground( pie_gc, &plot_area->style->bg[GTK_STATE_NORMAL] );
     gdk_draw_rectangle( pie, pie_gc, TRUE, 0, 0, x_size, y_size );

     for( i=0; i<NCOLORS; i++)
     {
       /* Set foreground and draw pie slice */
        gdk_gc_set_foreground( pie_gc, color + i );

        gdk_draw_arc( pie, pie_gc, TRUE, 0, 0, x_size*75/100, y_size*60/100, 
                       start*360*64/100, percents[i]*360*64/100 );
        start += percents[i];
        y = y_size*70/100 + 1.3*i*label_height;
        gdk_draw_rectangle( pie, pie_gc, TRUE, 
                            20, y, 10, label_height );
        gdk_draw_string( pie, plot_area->style->font, pie_gc,
                         35, y+label_height, pie_label[i] );

    }
    gdk_draw_pixmap( plot_area->window, pie_gc, pie, 0, 0, 
                     0, 0, x_size, y_size );
    gtk_object_set_data( GTK_OBJECT( plot_area ), "pixmap", pie );
    gdk_colormap_free_colors( colormap, color, NCOLORS );
    gdk_gc_unref( pie_gc );
} 
gboolean expose_handler( GtkWidget *widget, GdkEventExpose *event,
                         gpointer user_data )
{
  GdkGC *gc = gdk_gc_new( widget->window);
  GdkPixmap *pie_chart = gtk_object_get_data( GTK_OBJECT( widget ), "pixmap" ); 

  if( pie_chart )
      gdk_draw_pixmap( widget->window, gc, pie_chart, 
                       event->area.x, event->area.y, 
                       event->area.x, event->area.y, 
                       event->area.width, event->area.height );
  return TRUE;
}


