#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

static char * gtk_xpm[] =
{
    "15 20 16 1",
    "  c Gray0",   ". c #14121f", "X c #1d2f4d", "o c #24692a",
    "O c #284c72", "+ c #69282e", "@ c #515357", "# c #6d7076",
    "$ c #3b6ccb", "% c #278828", "& c #2fa232", "* c #37c539",
    "= c #3ce23d", "- c #9b3334", "; c #e24a49", ": c None",
    ":::::::::::::::", "::::::XXX@:::::", "::::@.X$$$X::::",
    ":::XXX....OX#::", "::X$X.$$$XX$$O:", ":.$$OX$OX$$$$O:",
    ":-+O$.OO.X$$o*:", ":-;+X$X.O$O&==:", ":-;;-+$$Xo*=&&:",
    ":-+.+-+o&*=o%&:", ":-;...-o&X&X=%:", ":-;+..-o%X.&=o:",
    ":-;++;;o%..o=O:", ":-;++;-ooo&.oO:", ":+;--;;oo%==*X:",
    "::+;;;-%o*=*X::", ":::+;;-&==%@:::", "::::+;-&*O:::::",
    ":::::@+oo::::::", "::::::@#:::::::"
};

GdkPixmap *gtk_pixmap = NULL;
GdkBitmap *gtk_mask = NULL;

gint counter = 0;
    
void fill_row(GtkWidget *clist, gint row)
{
    gchar **text = NULL;
    GtkStyle *newstyle = NULL;
    GdkColor color1;
    GdkColor color2;
    GdkColor color3;
    GdkColor color4;
    
    /* Create the contents of this row. The first column will
       display a small Gtk+ logo and the id of this row. The
       second and third columns will each contain a different
       random number. */
    text = g_new0(gchar*, 3);
    text[0] = g_new0(gchar, 20);
    text[1] = g_new0(gchar, 20);
    text[2] = g_new0(gchar, 20);
    
    sprintf(text[0], "row %d ", counter);
    sprintf(text[1], "%d", random());
    sprintf(text[2], "%d", random());
    
    /* Set the new row contents. */
    gtk_clist_set_pixtext(GTK_CLIST(clist), row, 0, text[0],
        5, gtk_pixmap, gtk_mask);
    gtk_clist_set_text(GTK_CLIST(clist), row, 1, text[1]);
    gtk_clist_set_text(GTK_CLIST(clist), row, 2, text[2]);
    
    /* Free the memory that was used to create the string that
       are displayed in this row. */
    g_free(text[2]);
    g_free(text[1]);
    g_free(text[0]);
    g_free(text);
    
    /* Define the colors that will be used to dsiplay the row's
       content. */
    
    /* light green */
    color1.red   = 0x3333;
    color1.green = 0xaaaa;
    color1.blue  = 0x3333;
    /* white */
    color2.red   = 0xffff;
    color2.green = 0xffff;
    color2.blue  = 0xffff;
    /* light gray */
    color3.red   = 0xcccc;
    color3.green = 0xcccc;
    color3.blue  = 0xcccc;
    /* dark green */
    color4.red   = 0x0000;
    color4.green = 0x6666;
    color4.blue  = 0x0000;
    
    /* Every 5 rows, set the background color to light gray. */
    if(counter % 5 == 0)
    {
        gtk_clist_set_background(GTK_CLIST(clist), row, &color3);
    }
    
    /* Create a copy of the clist GtkStyle and change it to
       modify the font, background and foreground of the first
       cell of this row, both in the normal as in the selected
       state. */
    newstyle = gtk_style_copy(clist->style);
    newstyle->base[GTK_STATE_NORMAL] = color1;
    newstyle->fg[GTK_STATE_NORMAL] = color2;
    newstyle->bg[GTK_STATE_SELECTED] = color3;
    newstyle->fg[GTK_STATE_SELECTED] = color4;
    gdk_font_unref(newstyle->font);
    newstyle->font = gdk_font_load
        ("-adobe-helvetica-bold-r-*-*-*-140-*-*-*-*-*-*");
    
    /* Set the new style for the first cell of this row. */
    gtk_clist_set_cell_style(GTK_CLIST(clist), row, 0,
        newstyle);
}

void populate_clist(GtkWidget *clist)
{
    gchar *text[3] = {"", "", ""};
    gint row = 0;

    /* Freeze the contents of the GtkCList. */
    gtk_clist_freeze(GTK_CLIST(clist));
    
    /* Create 100 empty rows and apply new contents and styles
       to them. */
    for(counter = 0; counter < 100; counter++)
    {
        row = gtk_clist_append(GTK_CLIST(clist), text);
        fill_row(clist, row);
        /* Since we're only interested in an integer that has
           to be stored with the row, namely the id at
           creation, it's best to cast it to a pointer instead
           of allocating additional data for a new integer and
           storing the pointer to the latter. */
        gtk_clist_set_row_data(GTK_CLIST(clist), row,
            (gpointer)counter);
    }
    
    /* Thaw the contents of the GtkCList. */
    gtk_clist_thaw(GTK_CLIST(clist));
}

gint row_compare(GtkCList *clist, GtkCListRow *row1,
         GtkCListRow *row2)
{
    /* Get the text that is being displayed by each row that
       has to be compared. */
    gchar *string1 =
        ((GtkCellText*)&(row1->cell[clist->sort_column]))->text;
    gchar *string2 =
        ((GtkCellText*)&(row2->cell[clist->sort_column]))->text;
    
    gint value1 = atoi(string1);
    gint value2 = atoi(string2);
    
    if(value1 == value2)
    {
        return 0;
    }
    else if(value1 < value2)
    {
        return -1;
    }
    else
    {
        return 1;
    }
}

void clist_click_column(GtkCList *clist, gint column,
         gpointer data)
{
    /* If the clicked column title corresponds to the column
       that's currently already sorted, just change the sort
       direction. */
    if(column == clist->sort_column)
    {
        if(clist->sort_type == GTK_SORT_ASCENDING)
        {
            gtk_clist_set_sort_type(GTK_CLIST(clist),
                GTK_SORT_DESCENDING);
        }
        else
        {
            gtk_clist_set_sort_type(GTK_CLIST(clist),
                GTK_SORT_ASCENDING);
        }
    }
    /* Otherwise, sort according to the newly clicked column.*/
    else
    {
        gtk_clist_set_sort_type(GTK_CLIST(clist),
            GTK_SORT_ASCENDING);
        gtk_clist_set_sort_column(clist, column);
    }
    
    /* Perform the sort. */
    gtk_clist_sort(clist);
}

void clist_select_row(GtkCList *clist, gint row, gint column,
         GdkEventButton *event, gpointer data)
{
    GtkWidget *statusbar = NULL;
    gchar buffer[255];
    
    statusbar = gtk_object_get_data(GTK_OBJECT(clist),
        "statusbar");
    gtk_statusbar_pop(GTK_STATUSBAR(statusbar), 1);
    /* Create a new string to display in the status bar that
       gives more details upon the action that occured. */
    sprintf(buffer,
        " row with id %d selected at position %d column %d",
        (gint)gtk_clist_get_row_data(clist, row), row, column);
    gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, buffer);
}

void clist_unselect_row(GtkCList *clist, gint row, gint column,
         GdkEventButton *event, gpointer data)
{
    GtkWidget *statusbar = NULL;
    gchar buffer[255];
    
    statusbar = gtk_object_get_data(GTK_OBJECT(clist),
        "statusbar");
    gtk_statusbar_pop(GTK_STATUSBAR(statusbar), 1);
    /* Create a new string to display in the status bar that
       gives more details upon the action that occured. */
    sprintf(buffer,
        " row with id %d unselected at position %d column %d",
        (gint)gtk_clist_get_row_data(clist, row), row, column);
    gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, buffer);
}

void button_top_clicked(GtkButton *button, GtkWidget *clist)
{
    gtk_clist_moveto(GTK_CLIST(clist), 0, 0, 0, 0);
}

void button_bottom_clicked(GtkButton *button, GtkWidget *clist)
{
    gtk_clist_moveto(GTK_CLIST(clist),
        GTK_CLIST(clist)->rows-1, 0, 1, 0);
}

void button_remove_selection_clicked(GtkButton *button,
         GtkWidget *clist)
{
    /* Freeze the contents of the GtkCList. */
    gtk_clist_freeze(GTK_CLIST(clist));
    
    /* Remove all rows that were selected. */
    while(GTK_CLIST(clist)->selection)
    {
        gtk_clist_remove(GTK_CLIST(clist),
            (gint)GTK_CLIST(clist)->selection->data);
    }
    
    /* Thaw the contents of the GtkCList. */
    gtk_clist_thaw(GTK_CLIST(clist));
}

void button_add_clicked(GtkButton *button, GtkWidget *clist)
{
    gchar *text[3] = {"", "", ""};
    gint row = 0;
    
    /* Insert a new row before the currently focused row. */
    row = gtk_clist_insert(GTK_CLIST(clist),
        GTK_CLIST(clist)->focus_row, text);
    fill_row(clist, row);
    counter++;
}

void button_select_all_clicked(GtkButton *button,
         GtkWidget *clist)
{
    gtk_clist_select_all(GTK_CLIST(clist));
}

void button_select_none_clicked(GtkButton *button,
         GtkWidget *clist)
{
    gtk_clist_unselect_all(GTK_CLIST(clist));
}


int main(int argc, char *argv[])
{
    GtkWidget *window = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *scrolled_window = NULL;
    GtkWidget *clist = NULL;
    GtkWidget *table = NULL;
    GtkWidget *button_top = NULL;
    GtkWidget *button_bottom = NULL;
    GtkWidget *button_remove_selection = NULL;
    GtkWidget *button_add = NULL;
    GtkWidget *button_select_all = NULL;
    GtkWidget *button_select_none = NULL;
    GtkWidget *statusbar = NULL;
    
    gtk_init(&argc, &argv);
    
    gtk_pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL,
	                 gdk_colormap_get_system(), &gtk_mask,
                     NULL, gtk_xpm);
    
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(window),
        "Chapter 15 : example 2");
    gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE,
        FALSE);
    gtk_window_set_default_size(GTK_WINDOW(window), -1, 300);
    gtk_container_set_border_width(GTK_CONTAINER(window), 5);
    gtk_signal_connect(GTK_OBJECT(window), "delete_event",
        (GtkSignalFunc)gtk_exit, NULL);
    
    vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_add(GTK_CONTAINER(window), vbox);
        
    scrolled_window = gtk_scrolled_window_new(NULL, NULL);
    gtk_scrolled_window_set_policy
        (GTK_SCROLLED_WINDOW(scrolled_window),
         GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_box_pack_start(GTK_BOX(vbox), scrolled_window,
        TRUE, TRUE, 0);
        
    clist = gtk_clist_new(3);
    gtk_widget_ensure_style(clist);
    gtk_clist_set_selection_mode(GTK_CLIST(clist),
        GTK_SELECTION_MULTIPLE);
    gtk_clist_set_row_height(GTK_CLIST(clist), 20);
    gtk_clist_set_compare_func(GTK_CLIST(clist),
        (GtkCListCompareFunc)row_compare);
    gtk_clist_set_sort_type(GTK_CLIST(clist),
        GTK_SORT_ASCENDING);
    gtk_clist_set_sort_column(GTK_CLIST(clist), 0);
    gtk_signal_connect(GTK_OBJECT(clist), "click_column",
        (GtkSignalFunc)clist_click_column, NULL);
    gtk_signal_connect(GTK_OBJECT(clist), "select_row",
        (GtkSignalFunc)clist_select_row, NULL);
    gtk_signal_connect(GTK_OBJECT(clist), "unselect_row",
        (GtkSignalFunc)clist_unselect_row, NULL);
    
    gtk_clist_set_column_title(GTK_CLIST(clist), 0,
        " Auto Resized ");
    gtk_clist_set_column_title(GTK_CLIST(clist), 1,
        " Column 2 ");
    gtk_clist_set_column_title(GTK_CLIST(clist), 2,
        " Column 3 ");
    gtk_clist_column_titles_show(GTK_CLIST(clist));
    
    gtk_clist_column_title_passive(GTK_CLIST(clist), 0);
    gtk_clist_column_title_active(GTK_CLIST(clist), 1);
    gtk_clist_column_title_active(GTK_CLIST(clist), 2);
    
    gtk_clist_set_column_resizeable(GTK_CLIST(clist), 0,
        FALSE);
    gtk_clist_set_column_auto_resize(GTK_CLIST(clist), 0,
        TRUE);
    
    gtk_clist_set_column_justification(GTK_CLIST(clist), 0,
        GTK_JUSTIFY_LEFT);
    gtk_clist_set_column_justification(GTK_CLIST(clist), 1,
        GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(GTK_CLIST(clist), 2,
        GTK_JUSTIFY_RIGHT);
    
    populate_clist(clist);
    
    gtk_container_add(GTK_CONTAINER(scrolled_window), clist);
    
    table = gtk_table_new(3, 2, TRUE);
    gtk_box_pack_start(GTK_BOX(vbox), table,
        FALSE, TRUE, 0);

    button_top = gtk_button_new_with_label(" Top ");
    gtk_signal_connect(GTK_OBJECT(button_top), "clicked",
        (GtkSignalFunc)button_top_clicked, clist);
    gtk_table_attach(GTK_TABLE(table), button_top,
        0, 1, 0, 1,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    
    button_bottom = gtk_button_new_with_label(" Bottom ");
    gtk_signal_connect(GTK_OBJECT(button_bottom), "clicked",
        (GtkSignalFunc)button_bottom_clicked, clist);
    gtk_table_attach(GTK_TABLE(table), button_bottom,
        1, 2, 0, 1,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    
    button_remove_selection =
        gtk_button_new_with_label(" Remove Selection ");
    gtk_signal_connect(GTK_OBJECT(button_remove_selection),
        "clicked",
        (GtkSignalFunc)button_remove_selection_clicked, clist);
    gtk_table_attach(GTK_TABLE(table), button_remove_selection,
        0, 1, 1, 2,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    
    button_add = gtk_button_new_with_label(" Add Row ");
    gtk_signal_connect(GTK_OBJECT(button_add), "clicked",
        (GtkSignalFunc)button_add_clicked, clist);
    gtk_table_attach(GTK_TABLE(table), button_add,
        1, 2, 1, 2,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    
    button_select_all =
        gtk_button_new_with_label(" Select All ");
    gtk_signal_connect(GTK_OBJECT(button_select_all),
        "clicked",
        (GtkSignalFunc)button_select_all_clicked, clist);
    gtk_table_attach(GTK_TABLE(table), button_select_all,
        0, 1, 2, 3,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    
    button_select_none =
        gtk_button_new_with_label(" Select None ");
    gtk_signal_connect(GTK_OBJECT(button_select_none),
        "clicked",
        (GtkSignalFunc)button_select_none_clicked, clist);
    gtk_table_attach(GTK_TABLE(table), button_select_none,
        1, 2, 2, 3,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL,
        GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    
    statusbar = gtk_statusbar_new();
    gtk_box_pack_start(GTK_BOX(vbox), statusbar,
        FALSE, TRUE, 0);
    gtk_object_set_data(GTK_OBJECT(clist), "statusbar",
        statusbar);
    
    gtk_widget_show_all(window);
    
    gtk_main();
    
    return 0;
}
