#include <gtk/gtk.h>

/* Callbacks */
GtkWidget *append_menu_item( GtkMenu *menu, const gchar *text, 
                   GtkSignalFunc callback, gpointer user_data);
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
void print_and_quit( GtkButton *was_clicked, gpointer user_data );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *vbox, *label, *menu_box;
  GtkWidget *drink, *entree, *side;
  GtkWidget *drink_menu, *entree_menu, *side_menu;

   /*  Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create toplevel widget */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    gtk_window_set_title( GTK_WINDOW( top_widget ), "Order" );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete-event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );

  /* Create managing vertical box widget */
    vbox = gtk_vbox_new( FALSE, 10 );
    gtk_container_add( GTK_CONTAINER( top_widget ), vbox );

  /* Create label widget */
    label = gtk_label_new( "Customer 1");
    gtk_box_pack_start_defaults( GTK_BOX( vbox ), label );

  /* Create managing horizontal box widget */
    menu_box = gtk_hbox_new( FALSE, 20 );
    gtk_box_pack_start_defaults( GTK_BOX( vbox ), menu_box );

   /* Create Drink option menu and associated submenu */
     drink = gtk_option_menu_new( );
      drink_menu = gtk_menu_new();
    
     /* Create Drink menu items */
     append_menu_item( GTK_MENU(drink_menu),  "Select Drink", NULL, NULL );
     append_menu_item( GTK_MENU(drink_menu),  "Iced Tea", NULL, NULL );
     append_menu_item( GTK_MENU(drink_menu),  "Cola", NULL, NULL );
     append_menu_item( GTK_MENU(drink_menu),  "Diet Cola", NULL, NULL );
     append_menu_item( GTK_MENU(drink_menu),  "Lemonade", NULL, NULL );

     gtk_option_menu_set_menu( GTK_OPTION_MENU(drink),  drink_menu  );
     gtk_box_pack_start_defaults( GTK_BOX( menu_box ), drink );

   /* Create Entree option menu and associated submenu */
     entree = gtk_option_menu_new( );
      entree_menu = gtk_menu_new();
    
     /* Create Entree menu items */
     append_menu_item( GTK_MENU(entree_menu),  "Select Entree", NULL, NULL );
     append_menu_item( GTK_MENU(entree_menu),  "Tacos", NULL, NULL );
     append_menu_item( GTK_MENU(entree_menu),  "Enchiladas", NULL, NULL );
     append_menu_item( GTK_MENU(entree_menu),  "Burrito", NULL, NULL );
     append_menu_item( GTK_MENU(entree_menu),  "Stuffed Sopapilla", NULL, NULL );

     gtk_option_menu_set_menu( GTK_OPTION_MENU(entree),  entree_menu  );
     gtk_box_pack_start_defaults( GTK_BOX( menu_box ), entree );

   /* Create Side Dish option menu and associated submenu */
     side = gtk_option_menu_new( );
      side_menu = gtk_menu_new();
    
     /* Create Side Dish menu items */
     append_menu_item( GTK_MENU(side_menu),  "Select Side Dish", NULL, NULL );
     append_menu_item( GTK_MENU(side_menu),  "Rice", NULL, NULL );
     append_menu_item( GTK_MENU(side_menu),  "Beans", NULL, NULL );
     append_menu_item( GTK_MENU(side_menu),  "Calabacitas", NULL, NULL );

     gtk_option_menu_set_menu( GTK_OPTION_MENU(side),  side_menu  );
     gtk_box_pack_start_defaults( GTK_BOX( menu_box ), side );


  /* Show the widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
