#include <gtk/gtk.h>
#define NO_PADDING 0
#define EXPAND_ON TRUE
#define FILL_FALSE FALSE


/* Callbacks */
GtkWidget *append_menu_item( GtkMenu *menu, const gchar *text, 
                   GtkSignalFunc callback, gpointer user_data);
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
void print_and_quit( GtkButton *was_clicked, gpointer user_data );

void toggle_smiley( GtkWidget *widget,  GtkWidget *area );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *scale; 
  GtkWidget *menu_bar, *file_item, *file_menu ;
  GtkWidget *tearoff;
  GtkObject *adj;

   /*  Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create toplevel widget */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete-event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );

  /* Create managing vertical box widget */
    box = gtk_vbox_new( FALSE, 0 );
    gtk_container_add( GTK_CONTAINER( top_widget ), box );

  /* Create the menu bar widget */
    menu_bar = gtk_menu_bar_new( );
    gtk_box_pack_start_defaults( GTK_BOX( box ), menu_bar );

    /* Create the File item and its menu widget */
     file_item = gtk_menu_item_new_with_label( "File" );
     gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), file_item );
      file_menu = gtk_menu_new();
      gtk_menu_item_set_submenu( GTK_MENU_ITEM( file_item ), file_menu );
    
     /* Create File menu items */
     tearoff = gtk_tearoff_menu_item_new( );
     gtk_menu_append( GTK_MENU(file_menu), tearoff );
     append_menu_item( GTK_MENU(file_menu),  "Exit", print_and_quit, NULL );

    adj = gtk_adjustment_new( 50.0, 0.0, 101.0, 0.1, 1.0, 1.0 );
    scale = gtk_hscale_new( GTK_ADJUSTMENT(adj) );
    gtk_widget_set_usize( scale, 150, 40 );
    gtk_box_pack_start_defaults( GTK_BOX( box ), scale );

  /* Show the widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
