#include <gtk/gtk.h>

gboolean OnWindowDeleteEvent(GtkWidget* widget, GdkEventAny* event, gpointer data)
{
	/*return false so that window will be destroyed*/
	return FALSE;
}

void OnWindowDestroy(GtkObject* object, gpointer data)
{
	/*exit main loop*/
	gtk_main_quit();
}


void OnButtonClicked(GtkButton* button, gpointer data)
{
	/*use a static variable to track where the button is in the fixed widget*/
	static gboolean moved = FALSE;
	
	GtkFixed* fixed;
	
	/*cast data to a GtkFixed pointer*/
	fixed = GTK_FIXED(data);
	
	/*move the button*/
	if(moved == TRUE)
	{
		/*the button isn't in it's orignal position so move it back to the upper-left corner*/
		gtk_fixed_move(fixed, GTK_WIDGET(button), 0, 0);
		moved = FALSE;
	}
	else
	{
		/*the button is in it's original position so move it to the center*/
		gtk_fixed_move(fixed, GTK_WIDGET(button), 150, 150);
		moved = TRUE;		
	}
}

int main (int argc, char** argv)
{
	GtkWidget* fixed;
	GtkWidget* window;
	GtkWidget* button;
	
	/*initialize gtk*/
	gtk_init(&argc, &argv);
	
	/*create the top level window*/
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), "Fixed Example");
	gtk_window_set_default_size(GTK_WINDOW(window), 300, 300);
	gtk_signal_connect(GTK_OBJECT(window), "delete-event", GTK_SIGNAL_FUNC(OnWindowDeleteEvent), NULL);
	gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(OnWindowDestroy), NULL);
	
	/*create the fixed widget and pack into window*/
	fixed = gtk_fixed_new();
	gtk_container_add(GTK_CONTAINER(window), fixed);
	
	/*create a button and put it in the fixed widget*/
	button = gtk_button_new_with_label("Press Me");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(OnButtonClicked), (gpointer)fixed);
	gtk_fixed_put(GTK_FIXED(fixed), button, 0, 0);
	
	/*show all the widgets*/
	gtk_widget_show_all(window);
	
	/*enter the main loop*/
	gtk_main();
	
	return 0;
}
