#include <gtk/gtk.h>
#include <stdio.h>

GtkWidget *append_menu_item( GtkMenu *menu, const gchar *text, 
                   GtkSignalFunc callback, gpointer user_data)
{
   GtkWidget *menu_item;
   if ( text )
   {
     menu_item = gtk_menu_item_new_with_label( text );
     gtk_object_set_data( GTK_OBJECT(menu), text, menu_item);
   }
   else
     menu_item = gtk_menu_item_new();

   gtk_menu_append( menu, menu_item );
   gtk_widget_show( menu_item );
   if (callback)
     gtk_signal_connect( GTK_OBJECT(menu_item), "activate", callback, user_data );
   return menu_item;
}
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data )
{
    /* Received closure from the window manager */
    g_print("The window manager is asking to close this application\n");
    return( FALSE );  /* FALSE - do not prevent closure */
}

void print_and_quit( GtkButton *was_clicked, gpointer user_data )
{
  /* Use glibs printf equivalent to print a message */
   g_print( "Thank you for using this program.\n");
   gtk_main_quit();
}

