#include <gtk/gtk.h>

/* Callbacks */
void print_and_quit( GtkButton *was_clicked, gpointer user_data );
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );

int main( gint argc, gchar *argv[] )
{
  GtkWidget *top_widget;
  GtkWidget *table, *frame[5], *message[5];
  gint i;

  /* Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create widgets */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    gtk_window_set_title( GTK_WINDOW( top_widget ), "Thoughts" );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete_event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );

    table = gtk_table_new( FALSE, 8, 10);
    gtk_container_add( GTK_CONTAINER( top_widget ), table );
 
   /* Create the frames */
    frame[0] = gtk_frame_new( "Abraham Lincoln" );
    gtk_frame_set_label_align( GTK_FRAME(frame[0]), 0.5, 0.0);
    gtk_frame_set_shadow_type( GTK_FRAME(frame[0]), GTK_SHADOW_IN);
    message[0] = gtk_label_new( "I always sleep better when I know\n"
                                "I have saved some poor soldier's life.");

    frame[1] = gtk_frame_new( "Sara in \"The Little Princess\", by "
                              "Frances Hodgson Burnett");
    gtk_frame_set_shadow_type( GTK_FRAME(frame[1]), GTK_SHADOW_OUT);
    message[1] = gtk_label_new( "I may not look like a princess dressed"
                   " in rags\nand tatters, but I can still remain a "
                   "princess inside.\nIt would be easy to be a princess"
                   "if I were dressed in\ncloth of gold, but a greater "
                   "triumph lies in remaining\nkind and generous and "
                   "noble toward those who see me only\n"
                   "in my rags and tatters.");

    frame[2] = gtk_frame_new( "Dr. Seuss");
    gtk_frame_set_shadow_type( GTK_FRAME(frame[2]), GTK_SHADOW_ETCHED_IN);
    message[2] = gtk_label_new( "So...\nbe your name Buxbaum or Bixby or Bray\n"
                           "or Mordecai Ali Van Allen O'Shea,\n"
                           "you're off to Great Places!\nToday is your day!\n"
                           "Your mountain is waiting.\nSo...get on your way!");

    frame[3] = gtk_frame_new( "Harry S. Truman" );
    gtk_frame_set_label_align( GTK_FRAME(frame[3]), 1.0, 0.0);
    gtk_frame_set_shadow_type( GTK_FRAME(frame[3]), GTK_SHADOW_ETCHED_OUT);
    message[3] = gtk_label_new( "The buck stops here.");

    frame[4] = gtk_frame_new( NULL );
    gtk_frame_set_shadow_type( GTK_FRAME(frame[4]), GTK_SHADOW_NONE);
    message[4] = gtk_label_new( "And where your treasure is, "
                                "there your heart will be also.");

    /* Establish instance hierarchy for the table */
    for( i=0; i<5; i++)
      gtk_container_add( GTK_CONTAINER(frame[i]), message[i]);

    gtk_table_attach_defaults( GTK_TABLE(table), frame[0] ,
               0 /*left */, 4 /* right */, 0 /*top*/, 4 /*bottom*/ );
    gtk_table_attach_defaults( GTK_TABLE(table), frame[1] ,
               0 /*left */, 4 /* right */, 4 /*top*/, 8 /*bottom*/ );
    gtk_table_attach_defaults( GTK_TABLE(table), frame[2] ,
               4 /*left */, 8 /* right */, 0 /*top*/, 4 /*bottom*/ );
    gtk_table_attach_defaults( GTK_TABLE(table), frame[3] ,
               4 /*left */, 8 /* right */, 4 /*top*/, 8 /*bottom*/ );
    gtk_table_attach_defaults( GTK_TABLE(table), frame[4] ,
               0 /*left */, 8 /* right */, 8 /*top*/, 10 /*bottom*/ );

  /*  Show the Widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    return 0;
}
