#include <gtk/gtk.h>
#define NO_PADDING 0
#define EXPAND_ON TRUE
#define FILL_FALSE FALSE


/* Callbacks */
GtkWidget *append_menu_item( GtkMenu *menu, const gchar *text, 
                   GtkSignalFunc callback, gpointer user_data);
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
void print_and_quit( GtkButton *was_clicked, gpointer user_data );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *scroller, *text; 
  GtkWidget *menu_bar, *file_item, *file_menu ;
  GdkColor text_color;

   /*  Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create toplevel widget */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete-event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );

  /* Create managing vertical box widget */
    box = gtk_vbox_new( FALSE, 0 );
    gtk_container_add( GTK_CONTAINER( top_widget ), box );

  /* Create the menu bar widget */
    menu_bar = gtk_menu_bar_new( );
    gtk_box_pack_start_defaults( GTK_BOX( box ), menu_bar );

    /* Create the File item and its menu widget */
     file_item = gtk_menu_item_new_with_label( "File" );
     gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), file_item );
      file_menu = gtk_menu_new();
      gtk_menu_item_set_submenu( GTK_MENU_ITEM( file_item ), file_menu );
    
     /* Create File menu items */
     append_menu_item( GTK_MENU(file_menu),  "Exit", print_and_quit, NULL );

  /* Create the scrolled window with text widget child */

    scroller = gtk_scrolled_window_new( FALSE, FALSE );
    gtk_widget_set_usize( scroller, 300, 150 );
    gtk_box_pack_start_defaults( GTK_BOX( box ), scroller );

    text = gtk_text_new( NULL, NULL );
    gtk_text_set_editable( GTK_TEXT(text), TRUE );
    gtk_widget_set_usize( text, 300, 150 );
    gtk_container_add( GTK_CONTAINER( scroller ), text );
    gtk_text_freeze( GTK_TEXT(text) );
    gtk_text_insert (GTK_TEXT (text), text->style->font, NULL, NULL, 
                     "Here is a simple, little example for a text\n"
                     "widget.  Often the text would be supplied from an "
                     "outside source,\nsuch as read in from a file.  Perhaps\n",
                     -1);
     /* Get yellow */
     if (!gdk_color_parse("Yellow", &text_color))
       g_error("couldn't parse yellow");
     if (!gdk_colormap_alloc_color(gdk_colormap_get_system(), &text_color,
                                      FALSE, TRUE))
             g_error("couldn't allocate color");

    gtk_text_insert (GTK_TEXT (text), text->style->font, 
                     &text->style->black, &text_color,
                     "Sarah's Silly Sayings", -1);
    gtk_text_insert (GTK_TEXT (text), text->style->font, NULL, NULL, " or ", -1);
     /* Get red */
     if (!gdk_color_parse("Red", &text_color))
       g_error("couldn't parse red");
     if (!gdk_colormap_alloc_color(gdk_colormap_get_system(), &text_color,
                                      FALSE, TRUE))
             g_error("couldn't allocate color");
    gtk_text_insert (GTK_TEXT (text), text->style->font, 
                     &text->style->black, &text_color,
                     "Rachel's Real Recipes\n", -1);

    gtk_text_insert (GTK_TEXT (text), text->style->font, NULL, NULL,
                     "\nThis is the example program that contains\n"
                     "a GtkScrolledWindow widget with a GtkText\nchild.  "
                     "NO viewport is needed, since GtkText\nhas adjustments.",
                     -1);

    gtk_text_thaw( GTK_TEXT(text) );

  /* Show the widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
