#include <gtk/gtk.h>

/* Callbacks */
void print_and_quit( GtkButton *was_clicked, gpointer user_data )
{
  /* Use glibs printf equivalent to print a message */
   g_print( "Thank you for using this program.\n");
   gtk_main_quit();
}

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *label, *separator, *exit_btn; 

   /* 1. Initialize the environment */
    gtk_init( &argc, &argv );

  /* 2a. Create widgets */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    box = gtk_vbox_new( FALSE, 10 );
    label = gtk_label_new( "GTK+ is fun!");
    separator = gtk_hseparator_new(  );
    exit_btn = gtk_button_new_with_label( "Exit" );

  /* 2b. Set attributes */
    gtk_window_set_title( GTK_WINDOW( top_widget ), "gtkfun" );
    gtk_container_set_border_width( GTK_CONTAINER( top_widget ), 15 );
    gtk_widget_set_name( top_widget, "gtkfun");
    gtk_widget_set_name( box, "vertical box");
    gtk_widget_set_name( label, "fun_label");
    gtk_widget_set_name( separator, "separator");
    gtk_widget_set_name( exit_btn, "exit");

  /* 3. Register callbacks */
    gtk_signal_connect( GTK_OBJECT( exit_btn ), "clicked",
                        print_and_quit, NULL );

  /* 4. Define instance hierarchy (pack the widgets) */
   gtk_container_add( GTK_CONTAINER( top_widget ), box );
   gtk_box_pack_start_defaults( GTK_BOX( box ), label );
   gtk_box_pack_start_defaults( GTK_BOX( box ), separator );
   gtk_box_pack_start_defaults( GTK_BOX( box ), exit_btn );

  /* 5. Show the widgets */
    gtk_widget_show_all( top_widget );

  /* 6. Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
