#include <gtk/gtk.h>
#define HOMOGENEOUS TRUE
#define NON_HOMOGENEOUS FALSE
#define EXPAND_YES TRUE
#define FILL_YES TRUE
#define FILL_NO FALSE
#define NO_SPACING 0
#define NO_PADDING 0
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data )
{
    g_print("Received closure from the window manager\n");
    gtk_main_quit();
    return( TRUE );  /* FALSE - do not prevent closure */
}
int main( int argc, char *argv[] )
{
  GtkWidget *top_widget; 
  GtkWidget *box1, *button1, *button2, *button3, *button4, *button5;

   /* 1. Initialize the environment */
    gtk_init( &argc, &argv );

  /* 2a. Create widgets */
   top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
   box1 = gtk_hbox_new( HOMOGENEOUS, NO_SPACING );
   button1 = gtk_button_new_with_label( "Box\nHOMOGENEOUS" );
   button2 = gtk_button_new_with_label( "Box\nNo spacing" );
   button3 = gtk_button_new_with_label( "Child-Expand\n(Forced True)" );
   button4 = gtk_button_new_with_label( "Child-Fill\n False " );
   button5 = gtk_button_new_with_label( "Child\nno spacing" );

  /* 2b. Set attributes */
    gtk_window_set_title( GTK_WINDOW( top_widget ), "Box 2" );

  /* 3. Register the clicked callback */
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete_event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );

  /* 4. Define the Instance hierarchy */
    gtk_box_pack_start( GTK_BOX( box1 ), button1, EXPAND_YES, FILL_NO, 
                        NO_PADDING );
    gtk_box_pack_start( GTK_BOX( box1 ), button2, EXPAND_YES, FILL_NO, 
                        NO_PADDING );
    gtk_box_pack_start( GTK_BOX( box1 ), button3, EXPAND_YES, FILL_NO, 
                        NO_PADDING );
    gtk_box_pack_start( GTK_BOX( box1 ), button4, EXPAND_YES, FILL_NO, 
                        NO_PADDING );
    gtk_box_pack_start( GTK_BOX( box1 ), button5, EXPAND_YES, FILL_NO, 
                        NO_PADDING );
    gtk_container_add( GTK_CONTAINER( top_widget ), box1 );

  /* 5. Show the widgets */
    gtk_widget_show_all( top_widget );

  /* 6. Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}

