#include <gtk/gtk.h>

/* Callbacks */
void print_and_quit( GtkButton *was_clicked, gpointer user_data )
{
  /* Use glibs printf equivalent to print a message */
   g_print( "Thank you for using this program.\n");
   gtk_main_quit();
}
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data )
{
    /* Received closure from the window manager */
    g_print("The window manager is asking to close this application\n");
    return( FALSE );  /* FALSE - do not prevent closure */
}

#define X_AXIS 180
#define Y_AXIS 175
#define X_PAD 20
#define Y_PAD 10
#define NUM_PTS 10
#define X 0
#define Y 1

void line_plot( GtkMenuItem *was_clicked, GtkWidget *where_to_draw )
{
   static gint to_plot[NUM_PTS][2] = { {0, 0}, {15, 20}, {30, 80}, 
                              {45, 30}, {60, 25}, {75, 90}, {90, 120}, 
                              {105, 170}, {120, 100}, {135, 0} };
   static GdkGC *plot_gc;
   static int first_time_in = 1;
   int pts;

  if( first_time_in )
  {
    /* Initialize GC */
    plot_gc = gdk_gc_new( GTK_WIDGET(where_to_draw)->window );
  }
  /* Draw Axis */
   gdk_draw_line( GTK_WIDGET(where_to_draw)->window, plot_gc, 
                  X_PAD, Y_AXIS + Y_PAD, X_PAD, Y_PAD );
   gdk_draw_line( GTK_WIDGET(where_to_draw)->window, plot_gc,
                  X_PAD, Y_AXIS + Y_PAD, X_PAD + X_AXIS, Y_AXIS + Y_PAD );
   
   for( pts = 1; pts < NUM_PTS; pts++)
        gdk_draw_line( GTK_WIDGET(where_to_draw)->window, plot_gc,
               to_plot[pts-1][X] + X_PAD, Y_AXIS + Y_PAD - to_plot[pts-1][Y],
               to_plot[pts][X] + X_PAD, Y_AXIS + Y_PAD - to_plot[pts][Y] );

   g_print( "Thank you for plotting.\n");
}
