#include <gtk/gtk.h>

/* Callbacks */
void print_and_quit( GtkButton *was_clicked, gpointer user_data )
{
  /* Use glibs printf equivalent to print a message */
   g_print( "Thank you for using this program.\n");
   gtk_main_quit();
}
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data )
{
    /* Received closure from the window manager */
    g_print("The window manager is asking to close this application\n");
    return( FALSE );  /* FALSE - do not prevent closure */
}

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *label, *separator_item; 
  GtkWidget *menu_bar, *file_item, *file_menu, *exit_item;


   /* 1. Initialize the environment */
    gtk_init( &argc, &argv );

  /* 2a. Create widgets */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    box = gtk_vbox_new( FALSE, 0 );
    menu_bar = gtk_menu_bar_new( );
     file_item = gtk_menu_item_new_with_label( "File" );
      file_menu = gtk_menu_new();
       separator_item = gtk_menu_item_new( );
       exit_item = gtk_menu_item_new_with_label( "Exit" );
    label = gtk_label_new( "GTK+ is fun!");


  /* 2b. Set attributes */
    gtk_window_set_title( GTK_WINDOW( top_widget ), "new_gtkfun" );
    gtk_container_set_border_width( GTK_CONTAINER( top_widget ), 0 );
    gtk_widget_set_name( top_widget, "new_gtkfun");

  /* 3. Register callbacks */
    gtk_signal_connect( GTK_OBJECT( exit_item ), "activate",
                        print_and_quit, NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete-event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );

  /* 4. Define instance hierarchy (pack the widgets) */
   gtk_container_add( GTK_CONTAINER( top_widget ), box );
   gtk_box_pack_start_defaults( GTK_BOX( box ), menu_bar );
   gtk_box_pack_start_defaults( GTK_BOX( box ), label );

    /* Pack the menu bar */
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), file_item );
    gtk_menu_item_set_submenu( GTK_MENU_ITEM( file_item ), file_menu );
    gtk_menu_append( GTK_MENU(file_menu), separator_item );
    gtk_menu_append( GTK_MENU(file_menu), exit_item );


  /* 5. Show the widgets */
    gtk_widget_show_all( top_widget );

  /* 6. Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
