#include <gtk/gtk.h>
#define NROWS 5
#define NCOLS 4

/* Callbacks */
void print_and_quit( GtkButton *was_clicked, gpointer user_data )
{
  /* Use glibs printf equivalent to print a message */
   g_print( "Thank you for using this program.\n");
   gtk_main_quit();
}
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data )
{
    g_print("Received closure from the window manager\n");
    return( FALSE );  /* FALSE - do not prevent closure */
}

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget;
  GtkWidget *table;
  GtkWidget *btn[13], *dot_btn, *enter_btn, *plus_btn, *minus_btn;
  gchar *btn_label[13] = { " 0          \nIns        ", "1\nEnd", "2\n", 
                           "3\nPg Dn", "4\n<-",  "5\n", "6\n->", 
                           "7\nHome", "8\n", "9\nPg Up", "Num\nLock",
                           "/",  "*" }; 
  gint i;

   /* 1. Initialize the environment */
    gtk_init( &argc, &argv );

  /* 2a. Create widgets */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    table = gtk_table_new( NROWS, NCOLS, TRUE );

   /* Easier for me to attach as soon as I create */
    for (i=0; i<13; i++)
       btn[i]= gtk_button_new_with_label( btn_label[i] );

    gtk_table_attach_defaults( GTK_TABLE( table), btn[0], 0, 2, 4, 5);
    for( i=0; i<3; i++)
    {
      gtk_table_attach_defaults( GTK_TABLE( table), btn[i+10], i, i+1, 0, 1 );
      gtk_table_attach_defaults( GTK_TABLE( table), btn[i+7], i, i+1, 1, 2 );
      gtk_table_attach_defaults( GTK_TABLE( table), btn[i+4], i, i+1, 2, 3 );
      gtk_table_attach_defaults( GTK_TABLE( table), btn[i+1], i, i+1, 3, 4 );
    }

    minus_btn= gtk_button_new_with_label( "-" );
    gtk_table_attach_defaults( GTK_TABLE( table), minus_btn, 3, 4, 0, 1);
    plus_btn= gtk_button_new_with_label( "+" );
    gtk_table_attach_defaults( GTK_TABLE( table), plus_btn, 3, 4, 1, 3);
    enter_btn= gtk_button_new_with_label( "Enter" );
    gtk_table_attach_defaults( GTK_TABLE( table), enter_btn, 3, 4, 3, 5);
    dot_btn= gtk_button_new_with_label( ".\nDel" );
    gtk_table_attach_defaults( GTK_TABLE( table), dot_btn, 2, 3, 4, 5);
     
  /* 2b. Set attributes */
    gtk_window_set_title( GTK_WINDOW( top_widget ), "Table" );

  /* 3. Register the callback */
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete_event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );

  /* 4. Define the Instance hierarchy */
   gtk_container_add( GTK_CONTAINER( top_widget ), table );

  /* 5. Show the widgets */
     gtk_widget_show_all( top_widget );

  /* 6. Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
