#include <gtk/gtk.h>
#define NO_PADDING 0
#define NO_SPACING 0

/* Callbacks */
void line_plot( GtkMenuItem *was_clicked, GtkWidget *where_to_draw );
void print_and_quit( GtkButton *was_clicked, gpointer user_data );
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget;
  GtkWidget *vbox, *menu_bar, *file_item, *file_menu, *exit_item;
  GtkWidget *plot_area;
  GtkWidget *plot_item;
  GtkWidget *help_item;

   /* 1. Initialize the environment */
    gtk_init( &argc, &argv );

  /* 2a. Create widgets */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    vbox = gtk_vbox_new( FALSE, NO_SPACING );
    menu_bar = gtk_menu_bar_new( );

    /* Create the File item and its menu */
    file_item = gtk_menu_item_new_with_label( "File" );
    file_menu = gtk_menu_new();
    exit_item = gtk_menu_item_new_with_label( "Exit" );
 
   /* Create the Plot item */
    plot_item = gtk_menu_item_new_with_label( "Plot" );

   /* Create the Help item */
    help_item = gtk_menu_item_new_with_label( "Help" );

   /* Create the Work Area */
    plot_area = gtk_drawing_area_new();

  /* 2b. Set Attributes */
    gtk_window_set_title( GTK_WINDOW( top_widget ), "Plotter" );
    gtk_drawing_area_size( GTK_DRAWING_AREA(plot_area), 300, 200 );

  /* 3. Registering Callback routines */
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete_event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );
    gtk_signal_connect( GTK_OBJECT( exit_item ), "activate",
                        print_and_quit, NULL );
    gtk_signal_connect( GTK_OBJECT( plot_item ), "activate",
                        line_plot, plot_area );

  /* 4. Defining the Instance Hierarchy */
    gtk_container_add( GTK_CONTAINER( top_widget ), vbox );
    gtk_box_pack_start( GTK_BOX(vbox), menu_bar, FALSE, FALSE, NO_PADDING);
    gtk_box_pack_start( GTK_BOX(vbox), plot_area, FALSE, FALSE, NO_PADDING );

    /* Pack the Menu Bar and move Help to Far Right */
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), file_item );
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), plot_item );
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), help_item );
    gtk_menu_item_right_justify( GTK_MENU_ITEM( help_item ) );

    /* Attach and pack the menus */
    gtk_menu_item_set_submenu( GTK_MENU_ITEM( file_item ), file_menu );
    gtk_menu_append( GTK_MENU(file_menu), exit_item );

  /* 5. Showing the Widgets */
    gtk_widget_show_all( top_widget );

  /* 6. Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
