#include <gtk/gtk.h>
#define NO_PADDING 0
#define NO_SPACING 0

/* Callbacks */
void line_plot( GtkMenuItem *was_clicked, GtkWidget *where_to_draw );
void print_and_quit( GtkButton *was_clicked, gpointer user_data );
gboolean delete_event_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
gboolean dialog_delete_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget;
  GtkWidget *vbox, *menu_bar, *file_item, *file_menu, *exit_item;
  GtkWidget *plot_item, *plot_area;
  GtkWidget *help_item;
  GtkWidget *help_menu, *query_item, *separator, *about_help;
  GtkWidget *copyright_dlg, *copyright_label, *copyright_ok;
  GtkWidget *overview_dialog, *overview_label, *overview_ok;
  GtkWidget *help_submenu, *copyright, *overview;

  GtkAccelGroup *accel_group, *file_accel_group;
  guint key;


  /* 1. Initialize the environment */
    gtk_init( &argc, &argv );

  /* 2a. Create widgets */
    top_widget = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    vbox = gtk_vbox_new( FALSE, NO_SPACING );
    menu_bar = gtk_menu_bar_new( );

   /* Create the File item and its menu */
    file_item = gtk_menu_item_new_with_label( "File" );
    file_menu = gtk_menu_new();
     exit_item = gtk_menu_item_new_with_label( "" );
     file_accel_group = gtk_menu_ensure_uline_accel_group( GTK_MENU( file_menu ));
     key = gtk_label_parse_uline( GTK_LABEL( GTK_BIN( exit_item )->child),
                     "_Exit" );
     gtk_widget_add_accelerator( exit_item, "activate", file_accel_group,
                     key, GDK_NONE, GDK_NONE );
              
 
   /* Create the Plot item */
    plot_item = gtk_menu_item_new_with_label( "Plot" );

   /* Create the Help item and its menus */
    help_item = gtk_menu_item_new_with_label( "Help" );
    help_menu = gtk_menu_new();
     query_item = gtk_menu_item_new_with_label( "What's This?");
     separator = gtk_menu_item_new();
     about_help = gtk_menu_item_new_with_label( "About my program" );
       help_submenu = gtk_menu_new(  );
       copyright = gtk_menu_item_new_with_label( "Coyright information");
       overview = gtk_menu_item_new_with_label( "Overview" );

   /* Create the Work Area */
    plot_area = gtk_drawing_area_new();

   /* Create pop-up dialogs */
   copyright_dlg  = gtk_dialog_new();
   copyright_label = gtk_label_new( "Author: You\n Version 0.0.1\n"
                                    "Freely distributable under LGPL" );
   copyright_ok = gtk_button_new_with_label( "OK" );

  /* Put the label in vbox, and the button in action_area */
   gtk_box_pack_start( GTK_BOX( GTK_DIALOG(copyright_dlg)->vbox), copyright_label,
              FALSE, FALSE, NO_PADDING );
   gtk_box_pack_start( GTK_BOX(GTK_DIALOG(copyright_dlg)->action_area), copyright_ok,
              FALSE, FALSE, NO_PADDING );
   gtk_widget_show( copyright_label );
   gtk_widget_show( copyright_ok );
  
   overview_dialog  = gtk_dialog_new();
   overview_label = gtk_label_new( "This is a simple plotting program\n"
                  "It currently accepts no outside data, \n"
                  "though this feature will be available in a future release.\n");
   overview_ok = gtk_button_new_with_label( "OK" );

  /* Put the label in vbox, and the button in action_area */
   gtk_box_pack_start( GTK_BOX( GTK_DIALOG(overview_dialog)->vbox), overview_label,
              FALSE, FALSE, NO_PADDING );
   gtk_box_pack_start( GTK_BOX(GTK_DIALOG(overview_dialog)->action_area), overview_ok,
              FALSE, FALSE, NO_PADDING );
   gtk_widget_show( overview_label );
   gtk_widget_show( overview_ok );

  /* Set up the accelerator group */
   accel_group = gtk_accel_group_new();
   gtk_accel_group_attach( accel_group, GTK_OBJECT( top_widget ) );
   gtk_widget_add_accelerator( exit_item, "activate", accel_group,
                   'Q', GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE );

  /* 2b. Set Attributes */
    gtk_window_set_title( GTK_WINDOW( top_widget ), "Plotter" );
    gtk_drawing_area_size( GTK_DRAWING_AREA(plot_area), 300, 200 );


  /* 3. Registering Callback routines */
    gtk_signal_connect( GTK_OBJECT( overview_dialog ), "delete_event",
                        GTK_SIGNAL_FUNC(dialog_delete_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( copyright_dlg ), "delete_event",
                        GTK_SIGNAL_FUNC(dialog_delete_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "delete_event",
                        GTK_SIGNAL_FUNC(delete_event_handler), NULL );
    gtk_signal_connect( GTK_OBJECT( top_widget ), "destroy",
                        GTK_SIGNAL_FUNC(print_and_quit), NULL );
    gtk_signal_connect( GTK_OBJECT( exit_item ), "activate",
                        print_and_quit, NULL );
    gtk_signal_connect( GTK_OBJECT( plot_item ), "activate",
                        line_plot, plot_area );
    gtk_signal_connect_object( GTK_OBJECT( copyright ), "activate",
           GTK_SIGNAL_FUNC( gtk_widget_show ), GTK_OBJECT( copyright_dlg ) );
    gtk_signal_connect_object( GTK_OBJECT( copyright_ok ), "clicked",
           GTK_SIGNAL_FUNC( gtk_widget_hide ), GTK_OBJECT( copyright_dlg ) );
    gtk_signal_connect_object( GTK_OBJECT( overview ), "activate",
           GTK_SIGNAL_FUNC( gtk_widget_show ), GTK_OBJECT( overview_dialog ) );
    gtk_signal_connect_object( GTK_OBJECT( overview_ok ), "clicked",
           GTK_SIGNAL_FUNC( gtk_widget_hide ), GTK_OBJECT( overview_dialog ) );

  /* 4. Defining the Instance Hierarchy */
    gtk_container_add( GTK_CONTAINER( top_widget ), vbox );
    gtk_box_pack_start( GTK_BOX(vbox), menu_bar, FALSE, FALSE, NO_PADDING);
    gtk_box_pack_start( GTK_BOX(vbox), plot_area, FALSE, FALSE, NO_PADDING );

    /* Pack the Menu Bar */
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), file_item );
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), plot_item );
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), help_item );

    /* Attach and pack the menus */
    gtk_menu_item_set_submenu( GTK_MENU_ITEM( file_item ), file_menu );
    gtk_menu_append( GTK_MENU(file_menu), exit_item );

    gtk_menu_item_set_submenu( GTK_MENU_ITEM( help_item ), help_menu );
    gtk_menu_append( GTK_MENU(help_menu), query_item );
    gtk_menu_append( GTK_MENU(help_menu), separator );
    gtk_menu_append( GTK_MENU(help_menu), about_help );
      gtk_menu_item_set_submenu( GTK_MENU_ITEM( about_help ), help_submenu );
      gtk_menu_append( GTK_MENU(help_submenu), copyright );
      gtk_menu_append( GTK_MENU(help_submenu), overview );


  /* 5. Showing the Widgets */
    gtk_widget_show_all( top_widget );

  /* 6. Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
