#include <gtk/gtk.h>
#define X_AXIS 60
#define Y_AXIS 60
#define X_PAD 150
#define Y_PAD 150
#define NUM_PTS 10
#define X 0
#define Y 1

void little_points(GtkWidget *where_to_draw, GdkGC *gc, gint x, gint y);
void little_plot(GtkWidget *where_to_draw, GdkGC *gc);
void little_grid(GtkWidget *where_to_draw, GdkGC *gc );
void little_star(GtkWidget *where_to_draw, GdkGC *gc );
void little_girl(GtkWidget *where_to_draw, GdkGC *gc, gint x, gint y );
void little_house(GtkWidget *where_to_draw, GdkGC *gc, gint x, gint y );

void little_primitives( GtkMenuItem *was_clicked, GtkWidget *where_to_draw )
{
   static int first_time_in = 1;
   static GdkPoint points_to_plot[NUM_PTS] = { 
                {   0,   0 }, {  15, 20 }, { 30,  80 }, {  45,  30 }, 
                {  60,  25 }, {  75, 90 }, { 90, 120 }, { 105, 170 }, 
                { 120, 100 }, { 135,  0 } };
   static gint to_plot[NUM_PTS][2] = { 
                {   0,   0 }, {  15, 20 }, { 30,  80 }, {  45,  30 }, 
                {  60,  25 }, {  75, 90 }, { 90, 120 }, { 105, 170 }, 
                { 120, 100 }, { 135,  0 } };
   GdkGC *gc = where_to_draw->style->black_gc ;

   little_house( where_to_draw, gc, 20, 50 );
   little_girl ( where_to_draw, gc, 200, 32 );
   little_star ( where_to_draw, gc );
   little_grid ( where_to_draw, gc );
   little_plot ( where_to_draw, gc );
   little_points ( where_to_draw, gc, 240, 180 );

}
void little_house(GtkWidget *where_to_draw, GdkGC *gc, gint x, gint y )
{
   GdkGC *house_gc;

   house_gc = where_to_draw->style->black_gc ;
 
   /* Roof */
   gdk_draw_rectangle( where_to_draw->window, house_gc, FALSE,
                       x, y, 70, 5 );
   /* Chimney */
   gdk_draw_rectangle( where_to_draw->window, house_gc, FALSE,
                       x+40, y-10, 5, 10 );
   /* House */
   gdk_draw_rectangle( where_to_draw->window, house_gc, FALSE,
                       x+10, y+5, 50, 50 );

   /* Windows */
   gdk_draw_rectangle( where_to_draw->window, house_gc, FALSE,
                       x+15, y+20, 10, 13 );
   gdk_draw_rectangle( where_to_draw->window, house_gc, FALSE,
                       x+45, y+20, 10, 13 );

   /* Door */
   gdk_draw_rectangle( where_to_draw->window, house_gc, FALSE,
                       x+30, y+35, 12, 20 );

   gdk_draw_string( where_to_draw->window, where_to_draw->style->font, house_gc, 25, 125, "Rectangles");
}
void little_girl( GtkWidget *where_to_draw, GdkGC *girl_gc, gint x, gint y )
{
  /* Draw face */
   gdk_draw_arc( where_to_draw->window, girl_gc, TRUE,
                     x+8, y+23, 40, 50, 0, 360*64 );
  /* Draw hair bow */
   gdk_draw_arc( where_to_draw->window, girl_gc, TRUE,
                     x, y, 50, 35, -5*64, 45*64 );
   gdk_draw_arc( where_to_draw->window, girl_gc, TRUE,
                     x, y, 50, 35, 165*64, 45*64 );

  /* Ears */
   gdk_draw_arc( where_to_draw->window, girl_gc, TRUE,
                     x, y+33, 8, 8, 0, 360*64 );
   gdk_draw_arc( where_to_draw->window, girl_gc, TRUE,
                     x+50, y+33, 8, 8, 0, 360*64 );

   gdk_draw_string( where_to_draw->window, where_to_draw->style->font, girl_gc, x+20, y+95, "Arcs");
}
void little_star( GtkWidget *where_to_draw, GdkGC *gc )
{
   GdkPoint vertices[5] = { { 140, 56 }, { 122, 104},  { 164, 74 },
                            { 116, 74 }, { 152, 104} };

  /* Draw 5 pointed star*/
   gdk_draw_polygon( where_to_draw->window, gc, TRUE,
                     vertices , 5 );

   gdk_draw_string( where_to_draw->window, where_to_draw->style->font, gc, 115, 125, "Polygon");
}
void little_grid( GtkWidget *where_to_draw, GdkGC *gc )
{
   GdkSegment grid[4] = { { 40,150  ,  40,220},  { 70,150  ,  70,220},
                          { 25,175  ,  85,175},  { 25, 200  ,  85, 200} };

  /* Draw */
   gdk_draw_segments( GTK_WIDGET(where_to_draw)->window, gc, grid , 4 );

   gdk_draw_string( where_to_draw->window, where_to_draw->style->font, gc, 40, 240, "Segments");


}
void little_plot( GtkWidget *where_to_draw, GdkGC *gc )
{
   static GdkPoint points_to_plot[NUM_PTS] = { 
                {   0,   0 }, {  5, 6 }, { 10,  26 }, {  15,  10 }, 
                {  20,  8 }, {  25, 30 }, { 30, 40 }, { 38, 58 }, 
                { 40, 33 }, { 45,  0 } };
   gint pts;
   static int first_time_in = 1;

   /* Adjust points */
    if (first_time_in)
    {
      for (pts=0; pts<NUM_PTS; pts++){
          points_to_plot[pts].x += X_PAD;
          points_to_plot[pts].y = Y_PAD + Y_AXIS - points_to_plot[pts].y;
      }
      first_time_in = 0;
    }
      
          
  /* Draw Axis */
   gdk_draw_line( where_to_draw->window, gc, 
                  X_PAD, Y_AXIS + Y_PAD, X_PAD, Y_PAD );
   gdk_draw_line( where_to_draw->window, gc,
                  X_PAD, Y_AXIS + Y_PAD, X_PAD + X_AXIS, Y_AXIS + Y_PAD );
   
  /* Plot */
       gdk_draw_lines( where_to_draw->window, gc,
               points_to_plot, NUM_PTS );

   gdk_draw_string( where_to_draw->window, where_to_draw->style->font, gc, X_PAD+15, Y_PAD+Y_AXIS+20, "Lines");
}
void little_points(GtkWidget *where_to_draw, GdkGC *gc, gint x, gint y )
{
   
   gdk_draw_point( where_to_draw->window, gc, x+10, y+10 );
   gdk_draw_point( where_to_draw->window, gc, x+10, y );
   gdk_draw_point( where_to_draw->window, gc, x+40, y+30 );
   gdk_draw_point( where_to_draw->window, gc, x+30, y-10 );
   gdk_draw_point( where_to_draw->window, gc, x+50, y+10 );

   gdk_draw_string( where_to_draw->window, where_to_draw->style->font, gc, x+15, y+50, "Points");
}
