#include <gtk/gtk.h>
#define HOMOGENEOUS_FALSE FALSE
#define PADDING 0

gboolean dialog_delete_handler( GtkWidget *widget, GdkEvent *event,
                               gpointer user_data );
void collect_color( GtkButton *was_clicked, gpointer user_data );
void draw_pie_chart( GtkButton *was_clicked, gpointer user_data );

GtkWidget *append_menu_item( GtkMenu *menu, const gchar *text, 
                   GtkSignalFunc callback, gpointer user_data);
GtkWidget *create_file_and_menu( GtkMenuBar *menu_bar );
GtkWidget *create_top_window( const gchar*title );

int main( int argc, char *argv[] )
{
  GtkWidget *top_widget, *box, *menu_bar, *pie_area; 
  GtkWidget *file_item, *pie_item, *pie_menu, *color_item;
  GtkWidget *color_selection;

   /*  Initialize the environment */
    gtk_init( &argc, &argv );

  /* Create toplevel widget */
    top_widget = create_top_window( "Pie Chart");

  /* Create managing vertical box widget */
    box = gtk_vbox_new( HOMOGENEOUS_FALSE, PADDING );
    gtk_container_add( GTK_CONTAINER( top_widget ), box );

  /* Create the menu bar widget */
    menu_bar = gtk_menu_bar_new( );
    gtk_box_pack_start_defaults( GTK_BOX( box ), menu_bar );

   /* Create the drawing area widget */
    pie_area = gtk_drawing_area_new( );
    gtk_drawing_area_size(GTK_DRAWING_AREA(pie_area), 200, 250 );
    gtk_box_pack_start_defaults( GTK_BOX( box ), pie_area);

   /* Create the color selection dialog widget */
    color_selection = gtk_color_selection_dialog_new("Please select a new color"
                                                     "for the pie chart wedge" );
    gtk_signal_connect( GTK_OBJECT( color_selection ), "delete-event",
                        GTK_SIGNAL_FUNC(dialog_delete_handler), NULL );

   /* Create the File item and its menu widget */
    file_item = create_file_and_menu( GTK_MENU_BAR(menu_bar) );

   /* Create the Pie item */
    pie_item = gtk_menu_item_new_with_label( "Pie" );
    gtk_menu_bar_append( GTK_MENU_BAR( menu_bar ), pie_item );

     /* Create Pie menu */
      pie_menu = gtk_menu_new();
      gtk_menu_item_set_submenu( GTK_MENU_ITEM( pie_item ), pie_menu );
      color_item = append_menu_item( GTK_MENU(pie_menu),  "Change color", 
                                     NULL, NULL );
      gtk_signal_connect_object( GTK_OBJECT( color_item ), "activate",
                                 GTK_SIGNAL_FUNC(gtk_widget_show), 
                                 GTK_OBJECT(color_selection) );
      gtk_signal_connect_object( GTK_OBJECT( 
                   GTK_COLOR_SELECTION_DIALOG(color_selection)->cancel_button), 
                   "clicked",
                    GTK_SIGNAL_FUNC(gtk_widget_hide), 
                    GTK_OBJECT(color_selection) );
      gtk_signal_connect( GTK_OBJECT( 
                   GTK_COLOR_SELECTION_DIALOG(color_selection)->ok_button), 
                   "clicked",
                    collect_color, pie_area );
      append_menu_item( GTK_MENU(pie_menu), NULL, NULL, NULL );
      append_menu_item( GTK_MENU(pie_menu), "Draw pie", draw_pie_chart, 
                        pie_area );

  /* Show the widgets */
    gtk_widget_show_all( top_widget );

  /* Processing Loop */
    gtk_main();
    g_print( "Bye!\n");
    return 0;
}
   
